#pragma once

#include "pwsplugin.h"
#include "ManagedRTValue.h"

using namespace System;

namespace PWSPlugin
{
	public ref class Invoker
	{
	public:
		enum class Style {
			Invoke = CS_INVOKE,
			Interrupt = CS_INTERRUPT,
		};

		enum class ExitState {
			Succeed = AYAF_SUCCEED,
			Cancel = AYAF_CANCEL,
			FatalError = AYAF_FATAL_ERROR,
			None = AYAF_NONE,
		};

		delegate void InvokeCallback(ExitState, ManagedRTValue^);

	private:
		TPWPInstance* instance;
		DWORD id;
		InvokeCallback^ callback;

	public:
		Invoker(TPWPInstance*, DWORD);
		int Invoke(Style, String^, String^, InvokeCallback^, ...array<Object^>^);
		void Callback(exit_state_t, ManagedRTValue^);
		void UpdateInstance(TPWPInstance*);
	};
}
