#include "stdafx.h"
#include "ManagedRTValue.h"

#include <msclr/marshal.h>
using namespace msclr::interop;

using namespace PWSPlugin;

ManagedRTValue::ManagedRTValue(IRTValue* value)
{
	this->value = value;
}

char ManagedRTValue::GetChar()
{
	return this->value->getChar();
}

int ManagedRTValue::GetInt()
{
	return this->value->getInt();
}

double ManagedRTValue::GetDouble()
{
	return this->value->getDouble();
}

String^ ManagedRTValue::GetString()
{
	return marshal_as<String^>(this->value->getString());
}

bool ManagedRTValue::GetBoolean()
{
	return (FALSE != this->value->getBoolean());
}

ManagedRTValue^ ManagedRTValue::GetReference()
{
	return gcnew ManagedRTValue(this->value->getReference());
}

ManagedRTArray^ ManagedRTValue::GetArray()
{
	return gcnew ManagedRTArray(this->value->getArray());
}

void ManagedRTValue::Set(char c)
{
	this->value->setChar(c);
}

void ManagedRTValue::Set(int i)
{
	this->value->setInt(i);
}

void ManagedRTValue::Set(double d)
{
	this->value->setDouble(d);
}

void ManagedRTValue::Set(String^ s)
{
	marshal_context ctx;
	this->value->setString(ctx.marshal_as<const char*>(s));
}

void ManagedRTValue::Set(bool b)
{
	this->value->setBoolean((b ? TRUE : FALSE));
}


/* --------------------------------------------------------------------------------- */
ManagedRTArray::ManagedRTArray(IRTArray* ar)
{
	this->ar = ar;
}

char ManagedRTArray::GetCharAt(int idx)
{
	return this->ar->getCharAt(idx);
}

int ManagedRTArray::GetIntAt(int idx)
{
	return this->ar->getIntAt(idx);
}

double ManagedRTArray::GetDoubleAt(int idx)
{
	return this->ar->getDoubleAt(idx);
}

String^ ManagedRTArray::GetStringAt(int idx)
{
	return marshal_as<String^>(this->ar->getStringAt(idx));
}

bool ManagedRTArray::GetBooleanAt(int idx)
{
	return (FALSE != this->ar->getBooleanAt(idx));
}

ManagedRTValue^ ManagedRTArray::GetReferenceAt(int idx)
{
	return gcnew ManagedRTValue(this->ar->getReferenceAt(idx));
}

ManagedRTArray^ ManagedRTArray::GetArrayAt(int idx)
{
	return gcnew ManagedRTArray(this->ar->getArrayAt(idx));
}


void ManagedRTArray::SetAt(int idx, char c)
{
	this->ar->setCharAt(idx, c);
}

void ManagedRTArray::SetAt(int idx, int i)
{
	this->ar->setIntAt(idx, i);
}

void ManagedRTArray::SetAt(int idx, double d)
{
	this->ar->setDoubleAt(idx, d);
}

void ManagedRTArray::SetAt(int idx, String^ s)
{
	marshal_context ctx;
	this->ar->setStringAt(idx, ctx.marshal_as<const char*>(s));
}

void ManagedRTArray::SetAt(int idx, bool b)
{
	this->ar->setBooleanAt(idx, (b ? TRUE : FALSE));
}

int ManagedRTArray::GetDimCount()
{
	return this->ar->getDimCount();
}

int ManagedRTArray::GetElementCount()
{
	return this->ar->getElementCount();
}

void ManagedRTArray::Clear()
{
	this->ar->emptyof();
}
