#pragma once

#include "pwsRTValue.h"

using namespace System;
using namespace System::Collections::Generic;

namespace PWSPlugin
{
	ref class ManagedRTArray;

	public ref class ManagedRTValue
	{
	internal:
		IRTValue *value;

	public:
		ManagedRTValue(IRTValue*);
		char GetChar();
		int GetInt();
		double GetDouble();
		String^ GetString();
		bool GetBoolean();

		ManagedRTValue^ GetReference();
		ManagedRTArray^ GetArray();

		void Set(char);
		void Set(int);
		void Set(double);
		void Set(String^);
		void Set(bool);
	};

	public ref class ManagedRTArray
	{
	internal:
		IRTArray *ar;

	public:
		ManagedRTArray(IRTArray*);

		char GetCharAt(int);
		int GetIntAt(int);
		double GetDoubleAt(int);
		String^ GetStringAt(int);
		bool GetBooleanAt(int);

		ManagedRTValue^ GetReferenceAt(int);
		ManagedRTArray^ GetArrayAt(int);

		void SetAt(int, char);
		void SetAt(int, int);
		void SetAt(int, double);
		void SetAt(int, String^);
		void SetAt(int, bool);

		int GetDimCount();
		int GetElementCount();

		void Clear();
	};
}
