#pragma once

#include "pwsplugin.h"
#include "SystemFunctions.h"
#include "PluginFunctions.h"
#include "PluginTimer.h"
#include "PluginMenu.h"
#include "IPlugin.h"
#include "IPluginInstance.h"

using namespace System;
using namespace System::Collections::Generic;

namespace PWSPlugin
{
	/**
	 * vOCCX^X
	 *
	 * NĂLN^1Ɋ֘A1
	 */
	public ref class PluginHost
	{
	internal:
		TPWPInstance* instance;

	public:
		delegate int SynchronizeProc(SystemFunctions^);

	private:
		System::Reflection::Assembly^ pluginAsm;
		IPluginInstance^ pluginInstance;
		PluginFunctions^ pluginFunctions;
		Dictionary<DWORD, PluginTimer^> timers;
		Dictionary<DWORD, Invoker^> invokers;
		Dictionary<DWORD, SynchronizeProc^> synchronizers;
		PluginMenu^ menu;
		SystemFunctions^ systemFunctions;

	public:
		property SystemFunctions^ SysFunc
		{
			SystemFunctions^ get() { return this->systemFunctions; }
		}
		property PluginMenu^ Menu
		{
			PluginMenu^ get() { return this->menu; }
		}

		PluginHost(IPlugin^, TPWPInstance*);

		PluginTimer^ CreateTimer(int, PluginTimer::Mode, PluginTimer::Proc^);
		Invoker^ CreateInvoker();
		int Synchronize(SynchronizeProc^);

		void Callback_PluginFunction(TPWPInstance*, List<ManagedRTValue^>^, ManagedRTValue^, DWORD);
		void Callback_Timer(TPWPInstance*, TPWPTimerHandle, DWORD);
		void Callback_Invoke(TPWPInstance*, exit_state_t, ManagedRTValue^, DWORD);
		void Callback_Menu(TPWPInstance*, String^);
		int Callback_Synchronize(TPWPInstance*, DWORD);

		~PluginHost();
		!PluginHost();

	private:
		void UpdateInstance(TPWPInstance* instance);
		void RegisterFunction(String^, PluginFunctions::Proc^, String^);
	
	internal:
		void ExceptionHandler(Exception^ e);

	};
}
