﻿using System;
using System.Collections.Generic;

namespace PWSPlugin
{
    public class PluginInstance : IPluginInstance
    {
        private Guid guid;
        private PluginHost host;
        private PluginMenuItem menu1;
        private Plugin parent;
        private string msg;

        public Guid Guid { get { return this.guid; } }

        public PluginInstance(Plugin parent)
        {
            this.guid = Guid.NewGuid();
            this.parent = parent;

            System.Diagnostics.Debug.WriteLine("Plugin constructed");
        }

        public void Initialize(PluginHost host)
        {
            this.host = host;
            //System.Diagnostics.Debug.WriteLine(host.SysFunc.GetExecPersonaType());

            //PluginTimer t = host.CreateTimer(10000, PluginTimer.Mode.Interval, new PluginTimer.Proc(timer));
            //t.Start();

            menu1 = host.Menu.Add(host.Menu.GetSetupMenuName() + "\nP2P地震情報連携プラグインの設定", PluginMenu.Style.Default, 0, new PluginMenuItem.Proc(menu_cb));
        }

        public void RegisterFunctions(IPluginInstance.FunctionRegistrar registrar)
        {
            //registrar("NH_TESTPLUGIN_test", new PluginFunctions.Proc(test), "iV()");
            //registrar("NH_TESTPLUGIN_test2", new PluginFunctions.Proc(test2), "iV(S)");
            //registrar("NH_TESTPLUGIN_test3", new PluginFunctions.Proc(test3), "iS()");
            //registrar("NH_TESTPLUGIN_test4", new PluginFunctions.Proc(test4), "iV()");
            //registrar("NH_TESTPLUGIN_test5", new PluginFunctions.Proc(test), "iV()");
        }

        public void Destroy()
        {
            this.parent.DestroyInstance(this);
        }

        public void Notify(string msg)
        {
            this.msg = msg;

            // このメソッドはChararina本体とは別のスレッドから呼び出されるので
            // SynchronizeでChararina本体側からNotifySyncを呼び出してもらう
            int retval = host.Synchronize(new PluginHost.SynchronizeProc(NotifySync));
        }

        int NotifySync(SystemFunctions sf)
        {
            // 綾織関数を呼ぶ
            host.CreateInvoker().Invoke(
                Invoker.Style.Interrupt,
                "eV(S)", "NH_P2PQUAKE_Notify", null,
                this.msg);
            return 0;
        }

        /*
        void test(List<ManagedRTValue> args, ManagedRTValue retVal, SystemFunctions sf)
        {
            String pluginPath = sf.GetPluginFolder();
            String dataFolder = sf.GetPersonaDataFolder();
            System.Windows.Forms.MessageBox.Show(pluginPath + "\n" + dataFolder);
        }

        void test2(List<ManagedRTValue> args, ManagedRTValue retVal, SystemFunctions sf)
        {
            System.Windows.Forms.MessageBox.Show(args[0].GetString());
        }

        // import string NH_TESTPLUGIN_test3()
        void test3(List<ManagedRTValue> args, ManagedRTValue retVal, SystemFunctions sf)
        {
            retVal.Set("文字列を返すテスト");
        }

        void test4(List<ManagedRTValue> args, ManagedRTValue retVal, SystemFunctions sf)
        {
            host.Menu.Rename(menu1, host.Menu.GetSetupMenuName() + "\nほげほげ");
        }

        void timer(SystemFunctions sf)
        {
            host.CreateInvoker().Invoke(Invoker.Style.Invoke, "eV(ISB)", "NH_TESTPLUGIN_cTest4", new Invoker.InvokeCallback(invoke_cb), -1234, "文字列", true);
        }
        
        void invoke_cb(Invoker.ExitState state, ManagedRTValue retVal)
        {
            System.Diagnostics.Debug.WriteLine("invoke_cb: state=" + state);
        }
        */

        void menu_cb(string item)
        {
            //System.Diagnostics.Debug.WriteLine("menu_cb: item=" + item);
            //int retval = host.Synchronize(new PluginHost.SynchronizeProc(sync));
            //System.Diagnostics.Debug.WriteLine("synchronize: retval=", retval);

            parent.ShowSettingDialog();
        }

        /*
        int sync(SystemFunctions sf)
        {
            System.Diagnostics.Debug.WriteLine("sync called");
            return 1;
        }
         */
    }
}
