﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace P2PQRelayClient_Net
{
    public partial class SettingForm : Form
    {
        public Action SettingSaved { get; set; }

        public SettingForm()
        {
            InitializeComponent();
        }

        private void SettingForm_Load(object sender, EventArgs e)
        {
            LoadSetting();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SaveSetting();
            this.SettingSaved();
            this.Close();
        }

        private void SettingForm_FormClosing(object sender, FormClosingEventArgs e)
        {
        }

        private void LoadSetting()
        {
            bool isEnableAutoDetect = P2PQRelayClient_Net.Properties.Settings.Default.EnableAutoDetect;
            this.radioButton_autoDetectServer.Checked = isEnableAutoDetect;
            this.radioButton_manualSetServer.Checked = !isEnableAutoDetect;
            this.numericUpDown_queryPort.Value = P2PQRelayClient_Net.Properties.Settings.Default.QueryPort;
            this.textBox_manualServerIpAddress.Text = P2PQRelayClient_Net.Properties.Settings.Default.CommIpAddr;
            this.numericUpDown_manualServerPort.Value = P2PQRelayClient_Net.Properties.Settings.Default.CommPort;
        }

        private void SaveSetting()
        {
            P2PQRelayClient_Net.Properties.Settings.Default.EnableAutoDetect = this.radioButton_autoDetectServer.Checked;
            P2PQRelayClient_Net.Properties.Settings.Default.QueryPort = (int)this.numericUpDown_queryPort.Value;
            P2PQRelayClient_Net.Properties.Settings.Default.CommIpAddr = this.textBox_manualServerIpAddress.Text;
            P2PQRelayClient_Net.Properties.Settings.Default.CommPort = (int)this.numericUpDown_manualServerPort.Value;
            P2PQRelayClient_Net.Properties.Settings.Default.Save();
        }

        private void linkLabel_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            string url = (sender as LinkLabel).Text;
            System.Diagnostics.Process.Start(url);
        }
    }
}
